# DateIntervalInfo Class Reference

DateIntervalInfo is a public class for encapsulating localizable date time interval patterns. More...

`#include <dtitvinf.h>`

Inheritance diagram for DateIntervalInfo:

## Public Member Functions
| DateIntervalInfo (UErrorCode &status)
| Default constructor.
| DateIntervalInfo (const Locale &locale, UErrorCode &status)
| Construct DateIntervalInfo for the given locale,.
| DateIntervalInfo (const DateIntervalInfo &)
| Copy constructor.
DateIntervalInfo & | operator= (const DateIntervalInfo &)
| Assignment operator.
virtual DateIntervalInfo * | clone (void) const
| Clone this object polymorphically.
virtual | ~DateIntervalInfo ()
| Destructor.
virtual UBool | operator== (const DateIntervalInfo &other) const
| Return true if another object is semantically equal to this one.
UBool | operator!= (const DateIntervalInfo &other) const
| Return true if another object is semantically unequal to this one.
void | setIntervalPattern (const UnicodeString &skeleton, UCalendarDateFields lrgDiffCalUnit, const UnicodeString &intervalPattern, UErrorCode &status)
| Provides a way for client to build interval patterns.
UnicodeString & | getIntervalPattern (const UnicodeString &skeleton, UCalendarDateFields field, UnicodeString &result, UErrorCode &status) const
| Get the interval pattern given skeleton and the largest different calendar field.
UnicodeString & | getFallbackIntervalPattern (UnicodeString &result) const
| Get the fallback interval pattern.
void | setFallbackIntervalPattern (const UnicodeString &fallbackPattern, UErrorCode &status)
| Re-set the fallback interval pattern.
UBool | getDefaultOrder () const
| Get default order -- whether the first date in pattern is later date or not.
virtual UClassID | getDynamicClassID () const
| ICU "poor man's RTTI", returns a UClassID for the actual class.
## Static Public Member Functions
static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.
## Friends
class | DateIntervalFormat
| DateIntervalFormat will need access to getBestSkeleton(), parseSkeleton(), enum IntervalPatternIndex, and calendarFieldToPatternIndex().
UBool | dtitvinfHashTableValueComparator (UHashTok val1, UHashTok val2)

## Detailed Description

DateIntervalInfo is a public class for encapsulating localizable date time interval patterns.

It is used by DateIntervalFormat.

For most users, ordinary use of DateIntervalFormat does not need to create DateIntervalInfo object directly. DateIntervalFormat will take care of it when creating a date interval formatter when user pass in skeleton and locale.

For power users, who want to create their own date interval patterns, or want to re-set date interval patterns, they could do so by directly creating DateIntervalInfo and manupulating it.

Logically, the interval patterns are mappings from (skeleton, the_largest_different_calendar_field) to (date_interval_pattern).

A skeleton

1. only keeps the field pattern letter and ignores all other parts in a pattern, such as space, punctuations, and string literals.
2. hides the order of fields.
3. might hide a field's pattern letter length.

   For those non-digit calendar fields, the pattern letter length is important, such as MMM, MMMM, and MMMMM; EEE and EEEE, and the field's pattern letter length is honored.

   For the digit calendar fields, such as M or MM, d or dd, yy or yyyy, the field pattern length is ignored and the best match, which is defined in date time patterns, will be returned without honor the field pattern letter length in skeleton.

The calendar fields we support for interval formatting are: year, month, date, day-of-week, am-pm, hour, hour-of-day, and minute. Those calendar fields can be defined in the following order: year > month > date > am-pm > hour > minute

The largest different calendar fields between 2 calendars is the first different calendar field in above order.

For example: the largest different calendar fields between "Jan 10, 2007" and "Feb 20, 2008" is year.

There is a set of pre-defined static skeleton strings. There are pre-defined interval patterns for those pre-defined skeletons in locales' resource files. For example, for a skeleton UDAT_YEAR_ABBR_MONTH_DAY, which is "yMMMd", in en_US, if the largest different calendar field between date1 and date2 is "year", the date interval pattern is "MMM d, yyyy - MMM d, yyyy", such as "Jan 10, 2007 - Jan 10, 2008". If the largest different calendar field between date1 and date2 is "month", the date interval pattern is "MMM d - MMM d, yyyy", such as "Jan 10 - Feb 10, 2007". If the largest different calendar field between date1 and date2 is "day", the date interval pattern is ""MMM d-d, yyyy", such as "Jan 10-20, 2007".

For date skeleton, the interval patterns when year, or month, or date is different are defined in resource files. For time skeleton, the interval patterns when am/pm, or hour, or minute is different are defined in resource files.

There are 2 dates in interval pattern. For most locales, the first date in an interval pattern is the earlier date. There might be a locale in which the first date in an interval pattern is the later date. We use fallback format for the default order for the locale. For example, if the fallback format is "{0} - {1}", it means the first date in the interval pattern for this locale is earlier date. If the fallback format is "{1} - {0}", it means the first date is the later date. For a particular interval pattern, the default order can be overriden by prefixing "latestFirst:" or "earliestFirst:" to the interval pattern. For example, if the fallback format is "{0}-{1}", but for skeleton "yMMMd", the interval pattern when day is different is "latestFirst:d-d MMM yy", it means by default, the first date in interval pattern is the earlier date. But for skeleton "yMMMd", when day is different, the first date in "d-d MMM yy" is the later date.

The recommended way to create a DateIntervalFormat object is to pass in the locale. By using a Locale parameter, the DateIntervalFormat object is initialized with the pre-defined interval patterns for a given or default locale.

Users can also create DateIntervalFormat object by supplying their own interval patterns. It provides flexibility for power users.

After a DateIntervalInfo object is created, clients may modify the interval patterns using setIntervalPattern function as so desired. Currently, users can only set interval patterns when the following calendar fields are different: ERA, YEAR, MONTH, DATE, DAY_OF_MONTH, DAY_OF_WEEK, AM_PM, HOUR, HOUR_OF_DAY, and MINUTE. Interval patterns when other calendar fields are different is not supported.

DateIntervalInfo objects are cloneable. When clients obtain a DateIntervalInfo object, they can feel free to modify it as necessary.

DateIntervalInfo are not expected to be subclassed. Data for a calendar is loaded out of resource bundles. To ICU 4.0, date interval patterns are only supported in Gregorian calendar.

Stable:
  ICU 4.0

Definition at line 168 of file dtitvinf.h.

## Constructor & Destructor Documentation

DateIntervalInfo::DateIntervalInfo | ( | UErrorCode & | status | ) |

Default constructor.

It does not initialize any interval patterns except that it initialize default fall-back pattern as "{0} - {1}", which can be reset by setFallbackIntervalPattern(). It should be followed by setFallbackIntervalPattern() and setIntervalPattern(), and is recommended to be used only for power users who wants to create their own interval patterns and use them to create date interval formatter.

Parameters:

  | status | output param set to success/failure code on exit

Internal:
  Do not use. This API is for internal use only. ICU 4.0

DateIntervalInfo::DateIntervalInfo | ( | const Locale & | locale,
|  | UErrorCode & | status |
| ) |  |  |

Construct DateIntervalInfo for the given locale,.

Parameters:

  | locale | the interval patterns are loaded from the Gregorian calendar data in this locale.
  | status | output param set to success/failure code on exit

Stable:
  ICU 4.0

DateIntervalInfo::DateIntervalInfo | ( | const DateIntervalInfo & |  | ) |

Copy constructor.

Stable:
  ICU 4.0

virtual DateIntervalInfo::~DateIntervalInfo | ( |  | ) | `[virtual]`

Destructor.

It is virtual to be safe, but it is not designed to be subclassed.

Stable:
  ICU 4.0

## Member Function Documentation

virtual DateIntervalInfo* DateIntervalInfo::clone | ( | void |  | ) | const`[virtual]`

Clone this object polymorphically.

The caller owns the result and should delete it when done.

Returns:
  a copy of the object

Stable:
  ICU 4.0

UBool DateIntervalInfo::getDefaultOrder | ( |  | ) | const

Get default order -- whether the first date in pattern is later date or not.

return default date ordering in interval pattern. TRUE if the first date in pattern is later date, FALSE otherwise.

Stable:
  ICU 4.0

virtual UClassID DateIntervalInfo::getDynamicClassID | ( |  | ) | const`[virtual]`

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable:
  ICU 4.0

Implements UObject.

UnicodeString& DateIntervalInfo::getFallbackIntervalPattern | ( | UnicodeString & | result | ) | const

Get the fallback interval pattern.

Parameters:

  | result | output param to receive the pattern

Returns:
  a reference to 'result'

Stable:
  ICU 4.0

UnicodeString& DateIntervalInfo::getIntervalPattern | ( | const UnicodeString & | skeleton,
|  | UCalendarDateFields | field,
|  | UnicodeString & | result,
|  | UErrorCode & | status |
| ) |  |  | const

Get the interval pattern given skeleton and the largest different calendar field.

Parameters:

  | skeleton | the skeleton
  | field | the largest different calendar field
  | result | output param to receive the pattern
  | status | output param set to success/failure code on exit

Returns:
  a reference to 'result'

Stable:
  ICU 4.0

static UClassID DateIntervalInfo::getStaticClassID | ( |  | ) | `[static]`

ICU "poor man's RTTI", returns a UClassID for this class.

Stable:
  ICU 4.0

UBool DateIntervalInfo::operator!= | ( | const DateIntervalInfo & | other | ) | const`[inline]`

Return true if another object is semantically unequal to this one.

Parameters:

  | other | the DateIntervalInfo object to be compared with.

Returns:
  true if other is semantically unequal to this.

Stable:
  ICU 4.0

Definition at line 518 of file dtitvinf.h.

References operator==().

DateIntervalInfo& DateIntervalInfo::operator= | ( | const DateIntervalInfo & |  | ) |

Assignment operator.

Stable:
  ICU 4.0

virtual UBool DateIntervalInfo::operator== | ( | const DateIntervalInfo & | other | ) | const`[virtual]`

Return true if another object is semantically equal to this one.

Parameters:

  | other | the DateIntervalInfo object to be compared with.

Returns:
  true if other is semantically equal to this.

Stable:
  ICU 4.0

Referenced by operator!=().

void DateIntervalInfo::setFallbackIntervalPattern | ( | const UnicodeString & | fallbackPattern,
|  | UErrorCode & | status |
| ) |  |  |

Re-set the fallback interval pattern.

In construction, default fallback pattern is set as "{0} - {1}". And constructor taking locale as parameter will set the fallback pattern as what defined in the locale resource file.

This method provides a way for user to replace the fallback pattern.

Parameters:

  | fallbackPattern | fall-back interval pattern.
  | status | output param set to success/failure code on exit

Stable:
  ICU 4.0

void DateIntervalInfo::setIntervalPattern | ( | const UnicodeString & | skeleton,
|  | UCalendarDateFields | lrgDiffCalUnit,
|  | const UnicodeString & | intervalPattern,
|  | UErrorCode & | status |
| ) |  |  |

Provides a way for client to build interval patterns.

User could construct DateIntervalInfo by providing a list of skeletons and their patterns.

For example:

     UErrorCode status = U_ZERO_ERROR;
     DateIntervalInfo dIntervalInfo = new DateIntervalInfo();
     dIntervalInfo->setFallbackIntervalPattern("{0} ~ {1}");
     dIntervalInfo->setIntervalPattern("yMd", UCAL_YEAR, "'from' yyyy-M-d 'to' yyyy-M-d", status);
     dIntervalInfo->setIntervalPattern("yMMMd", UCAL_MONTH, "'from' yyyy MMM d 'to' MMM d", status);
     dIntervalInfo->setIntervalPattern("yMMMd", UCAL_DAY, "yyyy MMM d-d", status, status);

Restriction: Currently, users can only set interval patterns when the following calendar fields are different: ERA, YEAR, MONTH, DATE, DAY_OF_MONTH, DAY_OF_WEEK, AM_PM, HOUR, HOUR_OF_DAY, and MINUTE. Interval patterns when other calendar fields are different are not supported.

Parameters:

  | skeleton | the skeleton on which interval pattern based
  | lrgDiffCalUnit | the largest different calendar unit.
  | intervalPattern | the interval pattern on the largest different calendar unit. For example, if lrgDiffCalUnit is "year", the interval pattern for en_US when year is different could be "'from' yyyy 'to' yyyy".
  | status | output param set to success/failure code on exit

Stable:
  ICU 4.0

## Friends And Related Function Documentation

friend class DateIntervalFormat`[friend]`

DateIntervalFormat will need access to getBestSkeleton(), parseSkeleton(), enum IntervalPatternIndex, and calendarFieldToPatternIndex().

Instead of making above public, make DateIntervalFormat a friend of DateIntervalInfo.

Definition at line 355 of file dtitvinf.h.

UBool dtitvinfHashTableValueComparator | ( | UHashTok | val1,
|  | UHashTok | val2 |
| ) |  |  | `[friend]`

Internal:
  Do not use. This API is for internal use only. ICU 4.0

The documentation for this class was generated from the following file:

- dtitvinf.h